#include <prismino.h>
#include <Servo.h> 
 
// the analog value is between 0 (white) and 1023 (black) so it needs a 16-bit variable
// can use "unsigned int" or "uint16_t" for short
uint16_t ir_value, ir_value_on, ir_value_off;
uint8_t btn;
uint16_t val;
Servo myservo;  // create servo object to control a servo 

void setup()
{
  // set pin output mode (toggles IR emitter current)
  // beware, this pin is connected on the same pin as the PRismino LED
  // do not try to toggle the PRismino LED or you will have unpredictable behaviour
  pinMode(13, OUTPUT);
  // enable button pull-up
  digitalWrite(7, 1);
  myservo.attach(5);  // attaches the servo on pin 5 to the servo object 
}

void loop()
{
  // read button state 
  btn = digitalRead(7);
  
  // button not pressed
  if(btn)
  {
    digitalWrite(13,1);             // turn on IR emitter
    delay(1);                       // time for switch on (may be way shorter, like 100us)
    ir_value = analogRead(A2);      // read IR sensor
    digitalWrite(13,0);             // turn off IR emitter (save battery)
    ir_value = 1023 - ir_value;     // to have the same scale as the other example
  }
  
  // button pressed 
  else
  {
    digitalWrite(13,1);             // turn on IR emitter
    delay(1);                       // time for switch on (may be way shorter, like 100us)
    ir_value_on = analogRead(A2);   // read IR sensor
    digitalWrite(13,0);             // turn off IR emitter (save battery)
    delay(1);                       // time for switch off (may be way shorter, like 100us)
    ir_value_off = analogRead(A2);  // read IR sensor
    
    ir_value = ir_value_off - ir_value_on;      // compute differential
  }
  
  // compute servomotor command (scales ir output to a value between 0° and 180°)
  val = map(ir_value, 0, 1023, 0, 180);
  
  // set servomotor position
  myservo.write(val);
  
  delay(100);
}

